=== debian/changelog ===
satdump (1.2.2-1build1) questing; urgency=medium

  * Rebuild against latest uhd

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sat, 03 May 2025 20:06:35 -0400

satdump (1.2.2-1) unstable; urgency=medium

  * Update d/watch to version 4 for real
  * d/watch ignore -winxp releases
  * New upstream version 1.2.2
  * Provide Appstream metadata for Satdump
  * Update overrides. Add libsatdump_interface and drop spelling error
  * Update d/rules to be verbose
  * Update d/copyright for new files
  * Update build dependencies to support more hardware
  * Bump standards version to 4.7.2. No changes required
  * Drop B-D ocl-icd-opencl-dev and intel-opencl-icd for Trixie

 -- Apostolos Kefalas <sv1ljj@raag.org>  Tue, 01 Apr 2025 13:05:42 +0300
