=== debian/control ===
Source: satdump
Section: hamradio
Priority: optional
Maintainer: Apostolos Kefalas <sv1ljj@raag.org>
Uploaders: Alex Myczko <tar@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               pkgconf,
               libfftw3-dev,
	       libtiff-dev,
               libjemalloc-dev,
	       libcurl4-openssl-dev,
               libvolk-dev|libvolk2-dev,
               libpng-dev,
               libnng-dev,
	       portaudio19-dev,
               libhdf5-dev,
               librtlsdr-dev,
               libhackrf-dev,
               libairspy-dev,
               libairspyhf-dev,
               libad9361-dev, libiio-dev,
               liblimesuite-dev|liblimesuite22.09-1,
	       libuhd-dev, libboost-dev,
               libbladerf-dev,
               libglfw3-dev,
	       zenity,
               libzstd-dev,
# Below B-D are optional, but recommended as it drastically increases
# speed of some operations
               libomp-dev [amd64 arm64 armhf mips64el ppc64el ppc64 riscv64],
	       libarmadillo-dev
Standards-Version: 4.7.2
Homepage: https://www.satdump.org
Vcs-Git: https://salsa.debian.org/svone/satdump.git
Vcs-Browser: https://salsa.debian.org/svone/satdump
Rules-Requires-Root: no

Package: satdump
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, satdump-data (= ${source:Version})
Description: Generic satellite data processing software
 It is a one-stop-shop that provides all the necessary
 stages to get from satellite transmission to actual products.
 Features:
   * Support of many SDRs such as RTL-SDR, Airspy, HackRF, BladeRF,
     LimeSDR, PlutoSDR, etc.
   * Recording of radio basebands from your SDR
   * Decoding and processing the data from over 90 different satellites
     and even space probes.
   * Live decoding of supported satellite links such as APT, LRPT, HRPT,
     LRIT, HRIT and many more.
   * Image and data decoding from satellites such as NOAA 15-18-19,
     Meteor-M, GOES, Elektro-L, Metop, FengYun, etc.
   * Calibrated and georefrenced L1b products output on select satellites,
     such as Sea Surface Temperature, Microphysics, etc. ready to use for
     scientific applications such as numerical weather forecasts.
   * Support for projecting the satellite imagery over a map, including
     layering with other instruments or satellites.
   * Inmarsat Aero and STD-C EGC messages decoding.
   * Scheduler and rotator control for automated satellite stations.
   * Ingestor for automated geostationary weather satellites reception.
 .
 This package provides satdump GUI, CLI and server.

Package: satdump-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Breaks: satdump (<<1.2.0)
Replaces: satdump(<<1.2.0)
Recommends: satdump
Description: Data files required for proper operation of satdump
 It is a one-stop-shop that provides all the necessary
 stages to get from satellite transmission to actual products.
 .
 This package provides data files of satdump.
